#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define FOR(i, a, b) for (int i=(a); i<(b); i++)
#define mp make_pair
#define fi first
#define se second
#define pb push_back

const int N = 1e4+9;
ll V[N];
vector<pair<int, ll> > adj[N];
ll D[N];
bool vis[N];

int n;

void djikstra(int s) {
	priority_queue<pair<ll, int> > Q;
	Q.push(mp(0, s));
	for(int i = 0; i <= n; ++i) {
		D[i] = 1000000000000LL;
	}
	D[s] = 0;
	while(!Q.empty()) {
		ll d = -Q.top().fi;
		int u = Q.top().se;
		Q.pop();
		if(!vis[u]) {
			vis[u] = true;
			D[u] = d;
			for(auto e : adj[u]) {
				int v = e.fi;
				ll w = e.se;
				if(D[u]+w < D[v]) {
					Q.push(mp(-D[u]-w, v));
				}
			}
		}
	}
}

int main()
{
	int m; cin >> n >> m;
	for(int i = 1; i <= n; ++i) {
		cin >> V[i];
		adj[0].pb(mp(i, V[i]));
		adj[i].pb(mp(0, V[i]));
	}
	for(int i = 1; i <= m; ++i) {
		int u, v, w; cin >> u >> v >> w;
		u++; v++;
		adj[u].pb(mp(v, w));
		adj[v].pb(mp(u, w));
		
	}
	djikstra(0);
	for(int i = 0; i <= n; ++i) {
		cout << D[i] << " ";
	}
	
	return 0;
}
