#include <bits/stdc++.h>
using namespace std;
#define pb push_back

using ll = long long int;

const int N = 3e5+9;
vector<int> adj[N];
ll A[N], B[N], ans[N];
ll n, q;

void dfs(int u) {
	ll k = adj[u].size();
	for(ll i = 0; i < k; ++i) {
		int v = adj[u][i];
		if(B[u] > q)
			B[v] = q+1;
		else
			B[v] = k*B[u];
		A[v] = A[u]+B[u]*i;
		if(A[v] > q)
			A[v] = q+1;
		
		dfs(v);
	}
}

int main(){
	cin.tie(NULL);
	ios_base::sync_with_stdio(0);
	
	cin >> n >> q;
	for(int i = 1; i < n; ++i) {
		int p; cin >> p;
		adj[p].pb(i);
	}
	A[0] = 1;
	B[0] = 1;
	dfs(0);
	/*for(int i = 0; i < n; ++i) {
		cout << A[i] << " " << B[i] << "\n";
	}*/
	for(int i = 0; i < n; ++i) {
		if(adj[i].size() == 0) {
			for(ll j = A[i]; j <= q; j += B[i]) {
				ans[j] = i;
			}
		}
	}
	for(int i = 1; i <= q; ++i) {
		cout << ans[i] << "\n";
	}

	return 0;
}
